// cxx-examples/src/rfc1155-smi.cpp - class definitions for ASN.1 module RFC1155-SMI
//
//   This file was generated by esnacc on Thu Dec  1 15:40:43 2016

//   NOTE: this is a machine generated file--editing not recommended


#include "cxx-examples/src/rfc1155-smi.h"

#ifndef NO_NAMESPACE
namespace SNACC {
#endif
//------------------------------------------------------------------------------
// value defs

const char *internet ="1.3.6.1";

const char *directory ="1.3.6.1.1";

const char *mgmt ="1.3.6.1.2";

const char *experimental ="1.3.6.1.3";

const char *myprivate ="1.3.6.1.4";

const char *enterprises ="1.3.6.1.4.1";


//------------------------------------------------------------------------------
// class member definitions:

AsnType *IpAddress::Clone() const
{
  return new IpAddress(*this);
}

AsnLen IpAddress::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, APPL, PRIM, 0);
    return l;
}

void IpAddress::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    FUNC("IpAddress::BDec");
    AsnTag tag;
    AsnLen elmtLen1;

    if (((tag = BDecTag (_b, bytesDecoded)) != MAKE_TAG_ID (APPL, PRIM, 0))
        && (tag != MAKE_TAG_ID (APPL, CONS, 0)))
    {
        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
    }
    elmtLen1 = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen1, bytesDecoded);
}

AsnType *Counter::Clone() const
{
  return new Counter(*this);
}

AsnLen Counter::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, APPL, PRIM, 1);
    return l;
}

void Counter::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    FUNC("Counter::BDec");
    AsnTag tag;
    AsnLen elmtLen1;

    if (((tag = BDecTag (_b, bytesDecoded)) != MAKE_TAG_ID (APPL, PRIM, 1)))
    {
        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
    }
    elmtLen1 = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen1, bytesDecoded);
}

AsnType *Gauge::Clone() const
{
  return new Gauge(*this);
}

AsnLen Gauge::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, APPL, PRIM, 2);
    return l;
}

void Gauge::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    FUNC("Gauge::BDec");
    AsnTag tag;
    AsnLen elmtLen1;

    if (((tag = BDecTag (_b, bytesDecoded)) != MAKE_TAG_ID (APPL, PRIM, 2)))
    {
        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
    }
    elmtLen1 = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen1, bytesDecoded);
}

AsnType *TimeTicks::Clone() const
{
  return new TimeTicks(*this);
}

AsnLen TimeTicks::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, APPL, PRIM, 3);
    return l;
}

void TimeTicks::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    FUNC("TimeTicks::BDec");
    AsnTag tag;
    AsnLen elmtLen1;

    if (((tag = BDecTag (_b, bytesDecoded)) != MAKE_TAG_ID (APPL, PRIM, 3)))
    {
        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
    }
    elmtLen1 = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen1, bytesDecoded);
}

AsnType *Opaque::Clone() const
{
  return new Opaque(*this);
}

AsnLen Opaque::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, APPL, PRIM, 4);
    return l;
}

void Opaque::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    FUNC("Opaque::BDec");
    AsnTag tag;
    AsnLen elmtLen1;

    if (((tag = BDecTag (_b, bytesDecoded)) != MAKE_TAG_ID (APPL, PRIM, 4))
        && (tag != MAKE_TAG_ID (APPL, CONS, 4)))
    {
        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
    }
    elmtLen1 = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen1, bytesDecoded);
}

SimpleSyntax::SimpleSyntax(const SimpleSyntax &that)
{
   Init();
   *this = that;
}
void SimpleSyntax::Init(void)
{
   // initialize choice to no choiceId to first choice and set pointer to NULL
  choiceId = numberCid;
  number = NULL;
}


int SimpleSyntax::checkConstraints(ConstraintFailList* pConstraintFails) const
{
	if (number != NULL)
		number->checkConstraints(pConstraintFails);

	if (string != NULL)
		string->checkConstraints(pConstraintFails);

	if (object != NULL)
		object->checkConstraints(pConstraintFails);

	if (empty != NULL)
		empty->checkConstraints(pConstraintFails);

	return 0;
}


void SimpleSyntax::Clear()
{
  switch (choiceId)
  {
    case numberCid:
      delete number;
      number = NULL;
      break;
    case stringCid:
      delete string;
      string = NULL;
      break;
    case objectCid:
      delete object;
      object = NULL;
      break;
    case emptyCid:
      delete empty;
      empty = NULL;
      break;
  } // end of switch
} // end of Clear()

AsnType *SimpleSyntax::Clone() const
{
  return new SimpleSyntax(*this);
}

SimpleSyntax &SimpleSyntax::operator = (const SimpleSyntax &that)
{
  if (this != &that)
  {
    Clear();
    // Check first type in choice to determine if choice is empty
    if (that.number != NULL)
    {
       switch (choiceId = that.choiceId)
       {
         case numberCid:
           number = new AsnInt(*that.number);
           break;
         case stringCid:
           string = new AsnOcts(*that.string);
           break;
         case objectCid:
           object = new AsnOid(*that.object);
           break;
         case emptyCid:
           empty = new AsnNull(*that.empty);
           break;
       }// end of switch
     }// end of if
  }

  return *this;
}

AsnLen
SimpleSyntax::BEncContent (AsnBuf &_b) const
{
    FUNC("SimpleSyntax::BEncContent (AsnBuf &_b)");
  AsnLen l=0;
  switch (choiceId)
  {
    case numberCid:
      l = number->BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, UNIV, PRIM, INTEGER_TAG_CODE);
      break;

    case stringCid:
      l = string->BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, UNIV, PRIM, OCTETSTRING_TAG_CODE);
      break;

    case objectCid:
      l = object->BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, UNIV, PRIM, OID_TAG_CODE);
      break;

    case emptyCid:
      l = empty->BEncContent (_b);
    BEncDefLenTo127 (_b, l);
    l++;

    l += BEncTag1 (_b, UNIV, PRIM, NULLTYPE_TAG_CODE);
      break;

      default:
         throw EXCEPT("Choice is empty", ENCODE_ERROR);
  } // end switch
  return l;
} // SimpleSyntax::BEncContent


void SimpleSyntax::BDecContent (const AsnBuf &_b, AsnTag tag, AsnLen elmtLen0, AsnLen &bytesDecoded /*, s env*/)
{
   FUNC("SimpleSyntax::BDecContent()");
   Clear();
  switch (tag)
  {
    case MAKE_TAG_ID (UNIV, PRIM, INTEGER_TAG_CODE):
      choiceId = numberCid;
        number = new AsnInt;
        number->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    case MAKE_TAG_ID (UNIV, PRIM, OCTETSTRING_TAG_CODE):
    case MAKE_TAG_ID (UNIV, CONS, OCTETSTRING_TAG_CODE):
      choiceId = stringCid;
        string = new AsnOcts;
        string->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    case MAKE_TAG_ID (UNIV, PRIM, OID_TAG_CODE):
      choiceId = objectCid;
        object = new AsnOid;
        object->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    case MAKE_TAG_ID (UNIV, PRIM, NULLTYPE_TAG_CODE):
      choiceId = emptyCid;
        empty = new AsnNull;
        empty->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    default:
    {        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
      break;
    }
  } // end switch
} // SimpleSyntax::BDecContent


AsnLen SimpleSyntax::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    return l;
}

void SimpleSyntax::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    AsnLen elmtLen = 0;
    AsnTag tag;

    /*  CHOICEs are a special case - grab identifying tag */
    /*  this allows easier handling of nested CHOICEs */
    tag = BDecTag (_b, bytesDecoded);
    elmtLen = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen, bytesDecoded);
}

void SimpleSyntax::Print(std::ostream& os, unsigned short indent) const
{
	switch (choiceId)
	{
	case numberCid:
		os << "number ";
		if (number)
			number->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	case stringCid:
		os << "string ";
		if (string)
			string->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	case objectCid:
		os << "object ";
		if (object)
			object->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	case emptyCid:
		os << "empty ";
		if (empty)
			empty->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	} // end of switch
} // end of SimpleSyntax::Print()

void SimpleSyntax::PrintXML (std::ostream &os, const char *lpszTitle) const
{
  if (lpszTitle)
  {
     os << "<" << lpszTitle;
        os << " typeName=\"SimpleSyntax\" type=\"CHOICE\">";
  }
  else
        os << "<SimpleSyntax type=\"CHOICE\">";
  switch (choiceId)
  {
    case numberCid:
      if (number)
        number->PrintXML(os,"number");
      else
      {
        os << "<number -- void3 -- /number>" << std::endl;
      }
      break;

    case stringCid:
      if (string)
        string->PrintXML(os,"string");
      else
      {
        os << "<string -- void3 -- /string>" << std::endl;
      }
      break;

    case objectCid:
      if (object)
        object->PrintXML(os,"object");
      else
      {
        os << "<object -- void3 -- /object>" << std::endl;
      }
      break;

    case emptyCid:
      if (empty)
        empty->PrintXML(os,"empty");
      else
      {
        os << "<empty -- void3 -- /empty>" << std::endl;
      }
      break;

  } // end of switch
  if (lpszTitle)
     os << "</" << lpszTitle << ">";
  else
        os << "</SimpleSyntax>";
} // SimpleSyntax::PrintXML

NetworkAddress::NetworkAddress(const NetworkAddress &that)
{
   Init();
   *this = that;
}
void NetworkAddress::Init(void)
{
   // initialize choice to no choiceId to first choice and set pointer to NULL
  choiceId = internetCid;
  internet = NULL;
}


int NetworkAddress::checkConstraints(ConstraintFailList* pConstraintFails) const
{
	if (internet != NULL)
		internet->checkConstraints(pConstraintFails);

	return 0;
}


void NetworkAddress::Clear()
{
  switch (choiceId)
  {
    case internetCid:
      delete internet;
      internet = NULL;
      break;
  } // end of switch
} // end of Clear()

AsnType *NetworkAddress::Clone() const
{
  return new NetworkAddress(*this);
}

NetworkAddress &NetworkAddress::operator = (const NetworkAddress &that)
{
  if (this != &that)
  {
    Clear();
    // Check first type in choice to determine if choice is empty
    if (that.internet != NULL)
    {
       switch (choiceId = that.choiceId)
       {
         case internetCid:
           internet = new IpAddress(*that.internet);
           break;
       }// end of switch
     }// end of if
  }

  return *this;
}

AsnLen
NetworkAddress::BEncContent (AsnBuf &_b) const
{
    FUNC("NetworkAddress::BEncContent (AsnBuf &_b)");
  AsnLen l=0;
  switch (choiceId)
  {
    case internetCid:
      l = internet->BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, APPL, PRIM, 0);
      break;

      default:
         throw EXCEPT("Choice is empty", ENCODE_ERROR);
  } // end switch
  return l;
} // NetworkAddress::BEncContent


void NetworkAddress::BDecContent (const AsnBuf &_b, AsnTag tag, AsnLen elmtLen0, AsnLen &bytesDecoded /*, s env*/)
{
   FUNC("NetworkAddress::BDecContent()");
   Clear();
  switch (tag)
  {
    case MAKE_TAG_ID (APPL, PRIM, 0):
    case MAKE_TAG_ID (APPL, CONS, 0):
      choiceId = internetCid;
        internet = new IpAddress;
        internet->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    default:
    {        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
      break;
    }
  } // end switch
} // NetworkAddress::BDecContent


AsnLen NetworkAddress::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    return l;
}

void NetworkAddress::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    AsnLen elmtLen = 0;
    AsnTag tag;

    /*  CHOICEs are a special case - grab identifying tag */
    /*  this allows easier handling of nested CHOICEs */
    tag = BDecTag (_b, bytesDecoded);
    elmtLen = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen, bytesDecoded);
}

void NetworkAddress::Print(std::ostream& os, unsigned short indent) const
{
	switch (choiceId)
	{
	case internetCid:
		os << "internet ";
		if (internet)
			internet->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	} // end of switch
} // end of NetworkAddress::Print()

void NetworkAddress::PrintXML (std::ostream &os, const char *lpszTitle) const
{
  if (lpszTitle)
  {
     os << "<" << lpszTitle;
        os << " typeName=\"NetworkAddress\" type=\"CHOICE\">";
  }
  else
        os << "<NetworkAddress type=\"CHOICE\">";
  switch (choiceId)
  {
    case internetCid:
      if (internet)
        internet->PrintXML(os,"internet");
      else
      {
        os << "<internet -- void3 -- /internet>" << std::endl;
      }
      break;

  } // end of switch
  if (lpszTitle)
     os << "</" << lpszTitle << ">";
  else
        os << "</NetworkAddress>";
} // NetworkAddress::PrintXML

ApplicationSyntax::ApplicationSyntax(const ApplicationSyntax &that)
{
   Init();
   *this = that;
}
void ApplicationSyntax::Init(void)
{
   // initialize choice to no choiceId to first choice and set pointer to NULL
  choiceId = addressCid;
  address = NULL;
}


int ApplicationSyntax::checkConstraints(ConstraintFailList* pConstraintFails) const
{
	if (address != NULL)
		address->checkConstraints(pConstraintFails);

	if (counter != NULL)
		counter->checkConstraints(pConstraintFails);

	if (gauge != NULL)
		gauge->checkConstraints(pConstraintFails);

	if (ticks != NULL)
		ticks->checkConstraints(pConstraintFails);

	if (arbitrary != NULL)
		arbitrary->checkConstraints(pConstraintFails);

	return 0;
}


void ApplicationSyntax::Clear()
{
  switch (choiceId)
  {
    case addressCid:
      delete address;
      address = NULL;
      break;
    case counterCid:
      delete counter;
      counter = NULL;
      break;
    case gaugeCid:
      delete gauge;
      gauge = NULL;
      break;
    case ticksCid:
      delete ticks;
      ticks = NULL;
      break;
    case arbitraryCid:
      delete arbitrary;
      arbitrary = NULL;
      break;
  } // end of switch
} // end of Clear()

AsnType *ApplicationSyntax::Clone() const
{
  return new ApplicationSyntax(*this);
}

ApplicationSyntax &ApplicationSyntax::operator = (const ApplicationSyntax &that)
{
  if (this != &that)
  {
    Clear();
    // Check first type in choice to determine if choice is empty
    if (that.address != NULL)
    {
       switch (choiceId = that.choiceId)
       {
         case addressCid:
           address = new NetworkAddress(*that.address);
           break;
         case counterCid:
           counter = new Counter(*that.counter);
           break;
         case gaugeCid:
           gauge = new Gauge(*that.gauge);
           break;
         case ticksCid:
           ticks = new TimeTicks(*that.ticks);
           break;
         case arbitraryCid:
           arbitrary = new Opaque(*that.arbitrary);
           break;
       }// end of switch
     }// end of if
  }

  return *this;
}

AsnLen
ApplicationSyntax::BEncContent (AsnBuf &_b) const
{
    FUNC("ApplicationSyntax::BEncContent (AsnBuf &_b)");
  AsnLen l=0;
  switch (choiceId)
  {
    case addressCid:
      l = address->BEncContent (_b);
      break;

    case counterCid:
      l = counter->BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, APPL, PRIM, 1);
      break;

    case gaugeCid:
      l = gauge->BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, APPL, PRIM, 2);
      break;

    case ticksCid:
      l = ticks->BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, APPL, PRIM, 3);
      break;

    case arbitraryCid:
      l = arbitrary->BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, APPL, PRIM, 4);
      break;

      default:
         throw EXCEPT("Choice is empty", ENCODE_ERROR);
  } // end switch
  return l;
} // ApplicationSyntax::BEncContent


void ApplicationSyntax::BDecContent (const AsnBuf &_b, AsnTag tag, AsnLen elmtLen0, AsnLen &bytesDecoded /*, s env*/)
{
   FUNC("ApplicationSyntax::BDecContent()");
   Clear();
  switch (tag)
  {
    case MAKE_TAG_ID (APPL, PRIM, 0):
    case MAKE_TAG_ID (APPL, CONS, 0):
      choiceId = addressCid;
        address = new NetworkAddress;
        address->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    case MAKE_TAG_ID (APPL, PRIM, 1):
      choiceId = counterCid;
        counter = new Counter;
        counter->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    case MAKE_TAG_ID (APPL, PRIM, 2):
      choiceId = gaugeCid;
        gauge = new Gauge;
        gauge->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    case MAKE_TAG_ID (APPL, PRIM, 3):
      choiceId = ticksCid;
        ticks = new TimeTicks;
        ticks->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    case MAKE_TAG_ID (APPL, PRIM, 4):
    case MAKE_TAG_ID (APPL, CONS, 4):
      choiceId = arbitraryCid;
        arbitrary = new Opaque;
        arbitrary->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    default:
    {        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
      break;
    }
  } // end switch
} // ApplicationSyntax::BDecContent


AsnLen ApplicationSyntax::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    return l;
}

void ApplicationSyntax::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    AsnLen elmtLen = 0;
    AsnTag tag;

    /*  CHOICEs are a special case - grab identifying tag */
    /*  this allows easier handling of nested CHOICEs */
    tag = BDecTag (_b, bytesDecoded);
    elmtLen = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen, bytesDecoded);
}

void ApplicationSyntax::Print(std::ostream& os, unsigned short indent) const
{
	switch (choiceId)
	{
	case addressCid:
		os << "address ";
		if (address)
			address->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	case counterCid:
		os << "counter ";
		if (counter)
			counter->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	case gaugeCid:
		os << "gauge ";
		if (gauge)
			gauge->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	case ticksCid:
		os << "ticks ";
		if (ticks)
			ticks->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	case arbitraryCid:
		os << "arbitrary ";
		if (arbitrary)
			arbitrary->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	} // end of switch
} // end of ApplicationSyntax::Print()

void ApplicationSyntax::PrintXML (std::ostream &os, const char *lpszTitle) const
{
  if (lpszTitle)
  {
     os << "<" << lpszTitle;
        os << " typeName=\"ApplicationSyntax\" type=\"CHOICE\">";
  }
  else
        os << "<ApplicationSyntax type=\"CHOICE\">";
  switch (choiceId)
  {
    case addressCid:
      if (address)
        address->PrintXML(os,"address");
      else
      {
        os << "<address -- void3 -- /address>" << std::endl;
      }
      break;

    case counterCid:
      if (counter)
        counter->PrintXML(os,"counter");
      else
      {
        os << "<counter -- void3 -- /counter>" << std::endl;
      }
      break;

    case gaugeCid:
      if (gauge)
        gauge->PrintXML(os,"gauge");
      else
      {
        os << "<gauge -- void3 -- /gauge>" << std::endl;
      }
      break;

    case ticksCid:
      if (ticks)
        ticks->PrintXML(os,"ticks");
      else
      {
        os << "<ticks -- void3 -- /ticks>" << std::endl;
      }
      break;

    case arbitraryCid:
      if (arbitrary)
        arbitrary->PrintXML(os,"arbitrary");
      else
      {
        os << "<arbitrary -- void3 -- /arbitrary>" << std::endl;
      }
      break;

  } // end of switch
  if (lpszTitle)
     os << "</" << lpszTitle << ">";
  else
        os << "</ApplicationSyntax>";
} // ApplicationSyntax::PrintXML

ObjectSyntax::ObjectSyntax(const ObjectSyntax &that)
{
   Init();
   *this = that;
}
void ObjectSyntax::Init(void)
{
   // initialize choice to no choiceId to first choice and set pointer to NULL
  choiceId = simpleCid;
  simple = NULL;
}


int ObjectSyntax::checkConstraints(ConstraintFailList* pConstraintFails) const
{
	if (simple != NULL)
		simple->checkConstraints(pConstraintFails);

	if (application_wide != NULL)
		application_wide->checkConstraints(pConstraintFails);

	return 0;
}


void ObjectSyntax::Clear()
{
  switch (choiceId)
  {
    case simpleCid:
      delete simple;
      simple = NULL;
      break;
    case application_wideCid:
      delete application_wide;
      application_wide = NULL;
      break;
  } // end of switch
} // end of Clear()

AsnType *ObjectSyntax::Clone() const
{
  return new ObjectSyntax(*this);
}

ObjectSyntax &ObjectSyntax::operator = (const ObjectSyntax &that)
{
  if (this != &that)
  {
    Clear();
    // Check first type in choice to determine if choice is empty
    if (that.simple != NULL)
    {
       switch (choiceId = that.choiceId)
       {
         case simpleCid:
           simple = new SimpleSyntax(*that.simple);
           break;
         case application_wideCid:
           application_wide = new ApplicationSyntax(*that.application_wide);
           break;
       }// end of switch
     }// end of if
  }

  return *this;
}

AsnLen
ObjectSyntax::BEncContent (AsnBuf &_b) const
{
    FUNC("ObjectSyntax::BEncContent (AsnBuf &_b)");
  AsnLen l=0;
  switch (choiceId)
  {
    case simpleCid:
      l = simple->BEncContent (_b);
      break;

    case application_wideCid:
      l = application_wide->BEncContent (_b);
      break;

      default:
         throw EXCEPT("Choice is empty", ENCODE_ERROR);
  } // end switch
  return l;
} // ObjectSyntax::BEncContent


void ObjectSyntax::BDecContent (const AsnBuf &_b, AsnTag tag, AsnLen elmtLen0, AsnLen &bytesDecoded /*, s env*/)
{
   FUNC("ObjectSyntax::BDecContent()");
   Clear();
  switch (tag)
  {
    case MAKE_TAG_ID (UNIV, PRIM, INTEGER_TAG_CODE):
    case MAKE_TAG_ID (UNIV, PRIM, OCTETSTRING_TAG_CODE):
    case MAKE_TAG_ID (UNIV, CONS, OCTETSTRING_TAG_CODE):
    case MAKE_TAG_ID (UNIV, PRIM, OID_TAG_CODE):
    case MAKE_TAG_ID (UNIV, PRIM, NULLTYPE_TAG_CODE):
      choiceId = simpleCid;
        simple = new SimpleSyntax;
        simple->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    case MAKE_TAG_ID (APPL, PRIM, 0):
    case MAKE_TAG_ID (APPL, CONS, 0):
    case MAKE_TAG_ID (APPL, PRIM, 1):
    case MAKE_TAG_ID (APPL, PRIM, 2):
    case MAKE_TAG_ID (APPL, PRIM, 3):
    case MAKE_TAG_ID (APPL, PRIM, 4):
    case MAKE_TAG_ID (APPL, CONS, 4):
      choiceId = application_wideCid;
        application_wide = new ApplicationSyntax;
        application_wide->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    default:
    {        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
      break;
    }
  } // end switch
} // ObjectSyntax::BDecContent


AsnLen ObjectSyntax::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    return l;
}

void ObjectSyntax::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    AsnLen elmtLen = 0;
    AsnTag tag;

    /*  CHOICEs are a special case - grab identifying tag */
    /*  this allows easier handling of nested CHOICEs */
    tag = BDecTag (_b, bytesDecoded);
    elmtLen = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen, bytesDecoded);
}

void ObjectSyntax::Print(std::ostream& os, unsigned short indent) const
{
	switch (choiceId)
	{
	case simpleCid:
		os << "simple ";
		if (simple)
			simple->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	case application_wideCid:
		os << "application-wide ";
		if (application_wide)
			application_wide->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	} // end of switch
} // end of ObjectSyntax::Print()

void ObjectSyntax::PrintXML (std::ostream &os, const char *lpszTitle) const
{
  if (lpszTitle)
  {
     os << "<" << lpszTitle;
        os << " typeName=\"ObjectSyntax\" type=\"CHOICE\">";
  }
  else
        os << "<ObjectSyntax type=\"CHOICE\">";
  switch (choiceId)
  {
    case simpleCid:
      if (simple)
        simple->PrintXML(os,"simple");
      else
      {
        os << "<simple -- void3 -- /simple>" << std::endl;
      }
      break;

    case application_wideCid:
      if (application_wide)
        application_wide->PrintXML(os,"application-wide");
      else
      {
        os << "<application-wide -- void3 -- /application-wide>" << std::endl;
      }
      break;

  } // end of switch
  if (lpszTitle)
     os << "</" << lpszTitle << ">";
  else
        os << "</ObjectSyntax>";
} // ObjectSyntax::PrintXML

#ifndef NO_NAMESPACE
} // namespace close
#endif
